# To build on Fedora 14 due to https://bugzilla.redhat.com/show_bug.cgi?id=715580
#% global _unitdir /lib/systemd/system

%global migrfile %{_var}/run/systemd-migrate_%{name}-%{version}-%{release}-%{arch}

Name:		3proxy
Version:		0.6.1
Release:		12%{?dist}.disabled3

Summary:		Tiny but very powerful proxy
Summary(ru):	Маленький, но крайне мощный прокси-сервер

License:		BSD or ASL 2.0 or GPLv2+ or LGPLv2+
Group:		System Environment/Daemons
Url:			http://3proxy.ru/?l=EN

Source0:		http://3proxy.ru/%{version}/%{name}-%{version}.tgz
Source1:		3proxy.init
Source2:		3proxy.cfg
Source3:		3proxy.service
# EPEL still require it
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildRequires:	dos2unix
Requires:		initscripts

# I correct config path in man only. It is fully Fedora related.
Patch0:		3proxy-0.6.1-config-path.patch

BuildRequires:  systemd-units
Requires(pre):  systemd-sysv chkconfig
Requires(post): systemd-units
Requires(preun): systemd-units
Requires(postun): systemd-units

%description
%{name} -- light proxy server.
Universal proxy server with HTTP, HTTPS, SOCKS v4, SOCKS v4a, SOCKS v5, FTP,
POP3, UDP and TCP portmapping, access control, bandwith control, traffic
limitation and accounting based on username, client IP, target IP, day time,
day of week, etc.

%description -l ru
%{name} -- маленький прокси сервер.
Это универсальное решение поддерживающее HTTP, HTTPS, SOCKS v4, SOCKS v4a,
SOCKS v5, FTP, POP3, UDP и TCP проброс портов (portmapping), списки доступа
управление скоростью доступа, ограничением трафика и статистикоу, базирующейся
на имени пользователя, слиентском IP адресе, IP цели, времени дня, дня недели
и т.д.

%package sysvinit
Summary:	Legacy SysV initscripts for %{name} server
Group:	System Environment/Daemons
Requires: %{name} = %{version}-%{release}
Requires(post): chkconfig
Requires(preun): chkconfig

%description sysvinit
Legacy SysV initscripts for init mechanisms such as upstart
which do not support the systemd unit file format.

%prep
%setup -q

%patch0 -p0 -b .man-cfg

# To use "fedora" CFLAGS (exported)
sed -i -e "s/CFLAGS =/CFLAGS +=/" Makefile.Linux

dos2unix Changelog

%build
%{__make} -f Makefile.Linux

%install
rm -rf %{buildroot}

mkdir -p %{buildroot}%{_sysconfdir}
mkdir -p %{buildroot}%{_sysconfdir}/NetworkManager/dispatcher.d/
mkdir -p %{buildroot}%{_mandir}/man{3,8}
mkdir -p %{buildroot}%{_localstatedir}/log/%{name}
install -m755 -D src/%{name} %{buildroot}%{_bindir}/%{name}
install -m755 -D src/dighosts %{buildroot}%{_bindir}/dighosts
install -m755 -D src/ftppr %{buildroot}%{_bindir}/ftppr
install -m755 -D src/mycrypt %{buildroot}%{_bindir}/mycrypt
install -m755 -D src/pop3p %{buildroot}%{_bindir}/pop3p
install -m755 -D src/%{name} %{buildroot}%{_bindir}/%{name}
install -m755 -D src/proxy %{buildroot}%{_bindir}/htproxy
install -m755 -D src/socks %{buildroot}%{_bindir}/socks
install -m755 -D src/tcppm %{buildroot}%{_bindir}/tcppm
install -m755 -D src/udppm %{buildroot}%{_bindir}/udppm

install -pD -m755 %{SOURCE1} %{buildroot}/%{_initrddir}/%{name}
install -pD -m644 %{SOURCE2} %{buildroot}/%{_sysconfdir}/%{name}.cfg
install -pD -m755 %{SOURCE3} %{buildroot}/%{_unitdir}/%{name}.service

	for man in man/*.{3,8} ; do
	install "$man" "%{buildroot}%{_mandir}/man${man:(-1)}/"
	done

cat > %{buildroot}%{_sysconfdir}/NetworkManager/dispatcher.d/40-%{name} <<EOF
#!/bin/sh

	if [ "\$2" = "up" ]; then
	/sbin/service %{name} condrestart || : # reload doesn't work
	fi
EOF

%clean
rm -rf %{buildroot}

%pre
rm -f %{migrfile} &>/dev/null
if [ $1 -gt 1 ] && [ ! -e %{_unitdir}/%{name}.service ] && \
   [ -e %{_initddir}/%{name} ] ; then
    systemd-sysv-convert --save %{name} &>/dev/null
    chkconfig --del %{name} &>/dev/null
    touch %{migrfile} &>/dev/null
fi
exit 0

%post
[ $1 -eq 1 ] && systemctl daemon-reload &>/dev/null || :

%preun
if [ $1 -eq 0 ] ; then
    systemctl --no-reload disable %{name}.service &>/dev/null
    systemctl stop %{name}.service &>/dev/null || :
fi

%postun
systemctl daemon-reload &>/dev/null
[ $1 -gt 0 ] && systemctl try-restart %{name}.service &>/dev/null || :

%triggerpostun -- %{name}
if [ $1 -gt 0 ] && [ -e %{migrfile} ] ; then
    systemctl daemon-reload &>/dev/null
    systemctl try-restart %{name}.service &>/dev/null
fi
rm -f %{migrfile} &>/dev/null || :

%post sysvinit
chkconfig --add %{name} &>/dev/null || :

%preun sysvinit
[ $1 -eq 0 ] && chkconfig --del %{name} &>/dev/null || :


%files
%defattr(-,root,root,-)
%{_bindir}/*
%config(noreplace) %{_sysconfdir}/%{name}.cfg
%attr(0755,root,root) %config %{_sysconfdir}/NetworkManager/dispatcher.d/40-%{name}
%{_localstatedir}/log/%{name}
%doc Readme Changelog authors copying news
%{_mandir}/man8/*.8.gz
%{_mandir}/man3/*.3.gz
%{_unitdir}/%{name}.service

%files sysvinit
%{_initrddir}/%{name}
